import { __assign, __awaiter, __generator } from "tslib";
import { HttpRequest as __HttpRequest } from "@aws-sdk/protocol-http";
import { decorateServiceException as __decorateServiceException, expectInt32 as __expectInt32, expectLong as __expectLong, expectNonNull as __expectNonNull, expectNumber as __expectNumber, expectString as __expectString, parseEpochTimestamp as __parseEpochTimestamp, } from "@aws-sdk/smithy-client";
import { DataSyncServiceException as __BaseException } from "../models/DataSyncServiceException";
import { InternalException, InvalidRequestException, } from "../models/models_0";
export var serializeAws_json1_1CancelTaskExecutionCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.1",
            "x-amz-target": "FmrsService.CancelTaskExecution",
        };
        body = JSON.stringify(serializeAws_json1_1CancelTaskExecutionRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_1CreateAgentCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.1",
            "x-amz-target": "FmrsService.CreateAgent",
        };
        body = JSON.stringify(serializeAws_json1_1CreateAgentRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_1CreateLocationEfsCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.1",
            "x-amz-target": "FmrsService.CreateLocationEfs",
        };
        body = JSON.stringify(serializeAws_json1_1CreateLocationEfsRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_1CreateLocationFsxLustreCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.1",
            "x-amz-target": "FmrsService.CreateLocationFsxLustre",
        };
        body = JSON.stringify(serializeAws_json1_1CreateLocationFsxLustreRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_1CreateLocationFsxOpenZfsCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.1",
            "x-amz-target": "FmrsService.CreateLocationFsxOpenZfs",
        };
        body = JSON.stringify(serializeAws_json1_1CreateLocationFsxOpenZfsRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_1CreateLocationFsxWindowsCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.1",
            "x-amz-target": "FmrsService.CreateLocationFsxWindows",
        };
        body = JSON.stringify(serializeAws_json1_1CreateLocationFsxWindowsRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_1CreateLocationHdfsCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.1",
            "x-amz-target": "FmrsService.CreateLocationHdfs",
        };
        body = JSON.stringify(serializeAws_json1_1CreateLocationHdfsRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_1CreateLocationNfsCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.1",
            "x-amz-target": "FmrsService.CreateLocationNfs",
        };
        body = JSON.stringify(serializeAws_json1_1CreateLocationNfsRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_1CreateLocationObjectStorageCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.1",
            "x-amz-target": "FmrsService.CreateLocationObjectStorage",
        };
        body = JSON.stringify(serializeAws_json1_1CreateLocationObjectStorageRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_1CreateLocationS3Command = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.1",
            "x-amz-target": "FmrsService.CreateLocationS3",
        };
        body = JSON.stringify(serializeAws_json1_1CreateLocationS3Request(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_1CreateLocationSmbCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.1",
            "x-amz-target": "FmrsService.CreateLocationSmb",
        };
        body = JSON.stringify(serializeAws_json1_1CreateLocationSmbRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_1CreateTaskCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.1",
            "x-amz-target": "FmrsService.CreateTask",
        };
        body = JSON.stringify(serializeAws_json1_1CreateTaskRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_1DeleteAgentCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.1",
            "x-amz-target": "FmrsService.DeleteAgent",
        };
        body = JSON.stringify(serializeAws_json1_1DeleteAgentRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_1DeleteLocationCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.1",
            "x-amz-target": "FmrsService.DeleteLocation",
        };
        body = JSON.stringify(serializeAws_json1_1DeleteLocationRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_1DeleteTaskCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.1",
            "x-amz-target": "FmrsService.DeleteTask",
        };
        body = JSON.stringify(serializeAws_json1_1DeleteTaskRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_1DescribeAgentCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.1",
            "x-amz-target": "FmrsService.DescribeAgent",
        };
        body = JSON.stringify(serializeAws_json1_1DescribeAgentRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_1DescribeLocationEfsCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.1",
            "x-amz-target": "FmrsService.DescribeLocationEfs",
        };
        body = JSON.stringify(serializeAws_json1_1DescribeLocationEfsRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_1DescribeLocationFsxLustreCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.1",
            "x-amz-target": "FmrsService.DescribeLocationFsxLustre",
        };
        body = JSON.stringify(serializeAws_json1_1DescribeLocationFsxLustreRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_1DescribeLocationFsxOpenZfsCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.1",
            "x-amz-target": "FmrsService.DescribeLocationFsxOpenZfs",
        };
        body = JSON.stringify(serializeAws_json1_1DescribeLocationFsxOpenZfsRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_1DescribeLocationFsxWindowsCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.1",
            "x-amz-target": "FmrsService.DescribeLocationFsxWindows",
        };
        body = JSON.stringify(serializeAws_json1_1DescribeLocationFsxWindowsRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_1DescribeLocationHdfsCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.1",
            "x-amz-target": "FmrsService.DescribeLocationHdfs",
        };
        body = JSON.stringify(serializeAws_json1_1DescribeLocationHdfsRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_1DescribeLocationNfsCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.1",
            "x-amz-target": "FmrsService.DescribeLocationNfs",
        };
        body = JSON.stringify(serializeAws_json1_1DescribeLocationNfsRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_1DescribeLocationObjectStorageCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.1",
            "x-amz-target": "FmrsService.DescribeLocationObjectStorage",
        };
        body = JSON.stringify(serializeAws_json1_1DescribeLocationObjectStorageRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_1DescribeLocationS3Command = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.1",
            "x-amz-target": "FmrsService.DescribeLocationS3",
        };
        body = JSON.stringify(serializeAws_json1_1DescribeLocationS3Request(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_1DescribeLocationSmbCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.1",
            "x-amz-target": "FmrsService.DescribeLocationSmb",
        };
        body = JSON.stringify(serializeAws_json1_1DescribeLocationSmbRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_1DescribeTaskCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.1",
            "x-amz-target": "FmrsService.DescribeTask",
        };
        body = JSON.stringify(serializeAws_json1_1DescribeTaskRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_1DescribeTaskExecutionCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.1",
            "x-amz-target": "FmrsService.DescribeTaskExecution",
        };
        body = JSON.stringify(serializeAws_json1_1DescribeTaskExecutionRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_1ListAgentsCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.1",
            "x-amz-target": "FmrsService.ListAgents",
        };
        body = JSON.stringify(serializeAws_json1_1ListAgentsRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_1ListLocationsCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.1",
            "x-amz-target": "FmrsService.ListLocations",
        };
        body = JSON.stringify(serializeAws_json1_1ListLocationsRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_1ListTagsForResourceCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.1",
            "x-amz-target": "FmrsService.ListTagsForResource",
        };
        body = JSON.stringify(serializeAws_json1_1ListTagsForResourceRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_1ListTaskExecutionsCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.1",
            "x-amz-target": "FmrsService.ListTaskExecutions",
        };
        body = JSON.stringify(serializeAws_json1_1ListTaskExecutionsRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_1ListTasksCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.1",
            "x-amz-target": "FmrsService.ListTasks",
        };
        body = JSON.stringify(serializeAws_json1_1ListTasksRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_1StartTaskExecutionCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.1",
            "x-amz-target": "FmrsService.StartTaskExecution",
        };
        body = JSON.stringify(serializeAws_json1_1StartTaskExecutionRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_1TagResourceCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.1",
            "x-amz-target": "FmrsService.TagResource",
        };
        body = JSON.stringify(serializeAws_json1_1TagResourceRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_1UntagResourceCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.1",
            "x-amz-target": "FmrsService.UntagResource",
        };
        body = JSON.stringify(serializeAws_json1_1UntagResourceRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_1UpdateAgentCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.1",
            "x-amz-target": "FmrsService.UpdateAgent",
        };
        body = JSON.stringify(serializeAws_json1_1UpdateAgentRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_1UpdateLocationHdfsCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.1",
            "x-amz-target": "FmrsService.UpdateLocationHdfs",
        };
        body = JSON.stringify(serializeAws_json1_1UpdateLocationHdfsRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_1UpdateLocationNfsCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.1",
            "x-amz-target": "FmrsService.UpdateLocationNfs",
        };
        body = JSON.stringify(serializeAws_json1_1UpdateLocationNfsRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_1UpdateLocationObjectStorageCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.1",
            "x-amz-target": "FmrsService.UpdateLocationObjectStorage",
        };
        body = JSON.stringify(serializeAws_json1_1UpdateLocationObjectStorageRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_1UpdateLocationSmbCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.1",
            "x-amz-target": "FmrsService.UpdateLocationSmb",
        };
        body = JSON.stringify(serializeAws_json1_1UpdateLocationSmbRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_1UpdateTaskCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.1",
            "x-amz-target": "FmrsService.UpdateTask",
        };
        body = JSON.stringify(serializeAws_json1_1UpdateTaskRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_1UpdateTaskExecutionCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.1",
            "x-amz-target": "FmrsService.UpdateTaskExecution",
        };
        body = JSON.stringify(serializeAws_json1_1UpdateTaskExecutionRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var deserializeAws_json1_1CancelTaskExecutionCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_1CancelTaskExecutionCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_1CancelTaskExecutionResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_1CancelTaskExecutionCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalException": return [3, 2];
                    case "com.amazonaws.datasync#InternalException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.datasync#InvalidRequestException": return [3, 4];
                }
                return [3, 6];
            case 2: return [4, deserializeAws_json1_1InternalExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_1CreateAgentCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_1CreateAgentCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_1CreateAgentResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_1CreateAgentCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalException": return [3, 2];
                    case "com.amazonaws.datasync#InternalException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.datasync#InvalidRequestException": return [3, 4];
                }
                return [3, 6];
            case 2: return [4, deserializeAws_json1_1InternalExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_1CreateLocationEfsCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_1CreateLocationEfsCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_1CreateLocationEfsResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_1CreateLocationEfsCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalException": return [3, 2];
                    case "com.amazonaws.datasync#InternalException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.datasync#InvalidRequestException": return [3, 4];
                }
                return [3, 6];
            case 2: return [4, deserializeAws_json1_1InternalExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_1CreateLocationFsxLustreCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_1CreateLocationFsxLustreCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_1CreateLocationFsxLustreResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_1CreateLocationFsxLustreCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalException": return [3, 2];
                    case "com.amazonaws.datasync#InternalException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.datasync#InvalidRequestException": return [3, 4];
                }
                return [3, 6];
            case 2: return [4, deserializeAws_json1_1InternalExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_1CreateLocationFsxOpenZfsCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_1CreateLocationFsxOpenZfsCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_1CreateLocationFsxOpenZfsResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_1CreateLocationFsxOpenZfsCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalException": return [3, 2];
                    case "com.amazonaws.datasync#InternalException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.datasync#InvalidRequestException": return [3, 4];
                }
                return [3, 6];
            case 2: return [4, deserializeAws_json1_1InternalExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_1CreateLocationFsxWindowsCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_1CreateLocationFsxWindowsCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_1CreateLocationFsxWindowsResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_1CreateLocationFsxWindowsCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalException": return [3, 2];
                    case "com.amazonaws.datasync#InternalException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.datasync#InvalidRequestException": return [3, 4];
                }
                return [3, 6];
            case 2: return [4, deserializeAws_json1_1InternalExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_1CreateLocationHdfsCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_1CreateLocationHdfsCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_1CreateLocationHdfsResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_1CreateLocationHdfsCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalException": return [3, 2];
                    case "com.amazonaws.datasync#InternalException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.datasync#InvalidRequestException": return [3, 4];
                }
                return [3, 6];
            case 2: return [4, deserializeAws_json1_1InternalExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_1CreateLocationNfsCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_1CreateLocationNfsCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_1CreateLocationNfsResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_1CreateLocationNfsCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalException": return [3, 2];
                    case "com.amazonaws.datasync#InternalException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.datasync#InvalidRequestException": return [3, 4];
                }
                return [3, 6];
            case 2: return [4, deserializeAws_json1_1InternalExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_1CreateLocationObjectStorageCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_1CreateLocationObjectStorageCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_1CreateLocationObjectStorageResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_1CreateLocationObjectStorageCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalException": return [3, 2];
                    case "com.amazonaws.datasync#InternalException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.datasync#InvalidRequestException": return [3, 4];
                }
                return [3, 6];
            case 2: return [4, deserializeAws_json1_1InternalExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_1CreateLocationS3Command = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_1CreateLocationS3CommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_1CreateLocationS3Response(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_1CreateLocationS3CommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalException": return [3, 2];
                    case "com.amazonaws.datasync#InternalException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.datasync#InvalidRequestException": return [3, 4];
                }
                return [3, 6];
            case 2: return [4, deserializeAws_json1_1InternalExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_1CreateLocationSmbCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_1CreateLocationSmbCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_1CreateLocationSmbResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_1CreateLocationSmbCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalException": return [3, 2];
                    case "com.amazonaws.datasync#InternalException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.datasync#InvalidRequestException": return [3, 4];
                }
                return [3, 6];
            case 2: return [4, deserializeAws_json1_1InternalExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_1CreateTaskCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_1CreateTaskCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_1CreateTaskResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_1CreateTaskCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalException": return [3, 2];
                    case "com.amazonaws.datasync#InternalException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.datasync#InvalidRequestException": return [3, 4];
                }
                return [3, 6];
            case 2: return [4, deserializeAws_json1_1InternalExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_1DeleteAgentCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_1DeleteAgentCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_1DeleteAgentResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_1DeleteAgentCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalException": return [3, 2];
                    case "com.amazonaws.datasync#InternalException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.datasync#InvalidRequestException": return [3, 4];
                }
                return [3, 6];
            case 2: return [4, deserializeAws_json1_1InternalExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_1DeleteLocationCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_1DeleteLocationCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_1DeleteLocationResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_1DeleteLocationCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalException": return [3, 2];
                    case "com.amazonaws.datasync#InternalException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.datasync#InvalidRequestException": return [3, 4];
                }
                return [3, 6];
            case 2: return [4, deserializeAws_json1_1InternalExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_1DeleteTaskCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_1DeleteTaskCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_1DeleteTaskResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_1DeleteTaskCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalException": return [3, 2];
                    case "com.amazonaws.datasync#InternalException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.datasync#InvalidRequestException": return [3, 4];
                }
                return [3, 6];
            case 2: return [4, deserializeAws_json1_1InternalExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_1DescribeAgentCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_1DescribeAgentCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_1DescribeAgentResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_1DescribeAgentCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalException": return [3, 2];
                    case "com.amazonaws.datasync#InternalException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.datasync#InvalidRequestException": return [3, 4];
                }
                return [3, 6];
            case 2: return [4, deserializeAws_json1_1InternalExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_1DescribeLocationEfsCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_1DescribeLocationEfsCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_1DescribeLocationEfsResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_1DescribeLocationEfsCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalException": return [3, 2];
                    case "com.amazonaws.datasync#InternalException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.datasync#InvalidRequestException": return [3, 4];
                }
                return [3, 6];
            case 2: return [4, deserializeAws_json1_1InternalExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_1DescribeLocationFsxLustreCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_1DescribeLocationFsxLustreCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_1DescribeLocationFsxLustreResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_1DescribeLocationFsxLustreCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalException": return [3, 2];
                    case "com.amazonaws.datasync#InternalException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.datasync#InvalidRequestException": return [3, 4];
                }
                return [3, 6];
            case 2: return [4, deserializeAws_json1_1InternalExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_1DescribeLocationFsxOpenZfsCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_1DescribeLocationFsxOpenZfsCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_1DescribeLocationFsxOpenZfsResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_1DescribeLocationFsxOpenZfsCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalException": return [3, 2];
                    case "com.amazonaws.datasync#InternalException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.datasync#InvalidRequestException": return [3, 4];
                }
                return [3, 6];
            case 2: return [4, deserializeAws_json1_1InternalExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_1DescribeLocationFsxWindowsCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_1DescribeLocationFsxWindowsCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_1DescribeLocationFsxWindowsResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_1DescribeLocationFsxWindowsCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalException": return [3, 2];
                    case "com.amazonaws.datasync#InternalException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.datasync#InvalidRequestException": return [3, 4];
                }
                return [3, 6];
            case 2: return [4, deserializeAws_json1_1InternalExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_1DescribeLocationHdfsCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_1DescribeLocationHdfsCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_1DescribeLocationHdfsResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_1DescribeLocationHdfsCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalException": return [3, 2];
                    case "com.amazonaws.datasync#InternalException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.datasync#InvalidRequestException": return [3, 4];
                }
                return [3, 6];
            case 2: return [4, deserializeAws_json1_1InternalExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_1DescribeLocationNfsCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_1DescribeLocationNfsCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_1DescribeLocationNfsResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_1DescribeLocationNfsCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalException": return [3, 2];
                    case "com.amazonaws.datasync#InternalException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.datasync#InvalidRequestException": return [3, 4];
                }
                return [3, 6];
            case 2: return [4, deserializeAws_json1_1InternalExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_1DescribeLocationObjectStorageCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_1DescribeLocationObjectStorageCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_1DescribeLocationObjectStorageResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_1DescribeLocationObjectStorageCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalException": return [3, 2];
                    case "com.amazonaws.datasync#InternalException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.datasync#InvalidRequestException": return [3, 4];
                }
                return [3, 6];
            case 2: return [4, deserializeAws_json1_1InternalExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_1DescribeLocationS3Command = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_1DescribeLocationS3CommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_1DescribeLocationS3Response(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_1DescribeLocationS3CommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalException": return [3, 2];
                    case "com.amazonaws.datasync#InternalException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.datasync#InvalidRequestException": return [3, 4];
                }
                return [3, 6];
            case 2: return [4, deserializeAws_json1_1InternalExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_1DescribeLocationSmbCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_1DescribeLocationSmbCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_1DescribeLocationSmbResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_1DescribeLocationSmbCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalException": return [3, 2];
                    case "com.amazonaws.datasync#InternalException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.datasync#InvalidRequestException": return [3, 4];
                }
                return [3, 6];
            case 2: return [4, deserializeAws_json1_1InternalExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_1DescribeTaskCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_1DescribeTaskCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_1DescribeTaskResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_1DescribeTaskCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalException": return [3, 2];
                    case "com.amazonaws.datasync#InternalException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.datasync#InvalidRequestException": return [3, 4];
                }
                return [3, 6];
            case 2: return [4, deserializeAws_json1_1InternalExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_1DescribeTaskExecutionCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_1DescribeTaskExecutionCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_1DescribeTaskExecutionResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_1DescribeTaskExecutionCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalException": return [3, 2];
                    case "com.amazonaws.datasync#InternalException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.datasync#InvalidRequestException": return [3, 4];
                }
                return [3, 6];
            case 2: return [4, deserializeAws_json1_1InternalExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_1ListAgentsCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_1ListAgentsCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_1ListAgentsResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_1ListAgentsCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalException": return [3, 2];
                    case "com.amazonaws.datasync#InternalException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.datasync#InvalidRequestException": return [3, 4];
                }
                return [3, 6];
            case 2: return [4, deserializeAws_json1_1InternalExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_1ListLocationsCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_1ListLocationsCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_1ListLocationsResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_1ListLocationsCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalException": return [3, 2];
                    case "com.amazonaws.datasync#InternalException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.datasync#InvalidRequestException": return [3, 4];
                }
                return [3, 6];
            case 2: return [4, deserializeAws_json1_1InternalExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_1ListTagsForResourceCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_1ListTagsForResourceCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_1ListTagsForResourceResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_1ListTagsForResourceCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalException": return [3, 2];
                    case "com.amazonaws.datasync#InternalException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.datasync#InvalidRequestException": return [3, 4];
                }
                return [3, 6];
            case 2: return [4, deserializeAws_json1_1InternalExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_1ListTaskExecutionsCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_1ListTaskExecutionsCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_1ListTaskExecutionsResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_1ListTaskExecutionsCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalException": return [3, 2];
                    case "com.amazonaws.datasync#InternalException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.datasync#InvalidRequestException": return [3, 4];
                }
                return [3, 6];
            case 2: return [4, deserializeAws_json1_1InternalExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_1ListTasksCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_1ListTasksCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_1ListTasksResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_1ListTasksCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalException": return [3, 2];
                    case "com.amazonaws.datasync#InternalException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.datasync#InvalidRequestException": return [3, 4];
                }
                return [3, 6];
            case 2: return [4, deserializeAws_json1_1InternalExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_1StartTaskExecutionCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_1StartTaskExecutionCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_1StartTaskExecutionResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_1StartTaskExecutionCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalException": return [3, 2];
                    case "com.amazonaws.datasync#InternalException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.datasync#InvalidRequestException": return [3, 4];
                }
                return [3, 6];
            case 2: return [4, deserializeAws_json1_1InternalExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_1TagResourceCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_1TagResourceCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_1TagResourceResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_1TagResourceCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalException": return [3, 2];
                    case "com.amazonaws.datasync#InternalException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.datasync#InvalidRequestException": return [3, 4];
                }
                return [3, 6];
            case 2: return [4, deserializeAws_json1_1InternalExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_1UntagResourceCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_1UntagResourceCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_1UntagResourceResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_1UntagResourceCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalException": return [3, 2];
                    case "com.amazonaws.datasync#InternalException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.datasync#InvalidRequestException": return [3, 4];
                }
                return [3, 6];
            case 2: return [4, deserializeAws_json1_1InternalExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_1UpdateAgentCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_1UpdateAgentCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_1UpdateAgentResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_1UpdateAgentCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalException": return [3, 2];
                    case "com.amazonaws.datasync#InternalException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.datasync#InvalidRequestException": return [3, 4];
                }
                return [3, 6];
            case 2: return [4, deserializeAws_json1_1InternalExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_1UpdateLocationHdfsCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_1UpdateLocationHdfsCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_1UpdateLocationHdfsResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_1UpdateLocationHdfsCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalException": return [3, 2];
                    case "com.amazonaws.datasync#InternalException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.datasync#InvalidRequestException": return [3, 4];
                }
                return [3, 6];
            case 2: return [4, deserializeAws_json1_1InternalExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_1UpdateLocationNfsCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_1UpdateLocationNfsCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_1UpdateLocationNfsResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_1UpdateLocationNfsCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalException": return [3, 2];
                    case "com.amazonaws.datasync#InternalException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.datasync#InvalidRequestException": return [3, 4];
                }
                return [3, 6];
            case 2: return [4, deserializeAws_json1_1InternalExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_1UpdateLocationObjectStorageCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_1UpdateLocationObjectStorageCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_1UpdateLocationObjectStorageResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_1UpdateLocationObjectStorageCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalException": return [3, 2];
                    case "com.amazonaws.datasync#InternalException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.datasync#InvalidRequestException": return [3, 4];
                }
                return [3, 6];
            case 2: return [4, deserializeAws_json1_1InternalExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_1UpdateLocationSmbCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_1UpdateLocationSmbCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_1UpdateLocationSmbResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_1UpdateLocationSmbCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalException": return [3, 2];
                    case "com.amazonaws.datasync#InternalException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.datasync#InvalidRequestException": return [3, 4];
                }
                return [3, 6];
            case 2: return [4, deserializeAws_json1_1InternalExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_1UpdateTaskCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_1UpdateTaskCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_1UpdateTaskResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_1UpdateTaskCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalException": return [3, 2];
                    case "com.amazonaws.datasync#InternalException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.datasync#InvalidRequestException": return [3, 4];
                }
                return [3, 6];
            case 2: return [4, deserializeAws_json1_1InternalExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_1UpdateTaskExecutionCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_1UpdateTaskExecutionCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_1UpdateTaskExecutionResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_1UpdateTaskExecutionCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalException": return [3, 2];
                    case "com.amazonaws.datasync#InternalException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.datasync#InvalidRequestException": return [3, 4];
                }
                return [3, 6];
            case 2: return [4, deserializeAws_json1_1InternalExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
var deserializeAws_json1_1InternalExceptionResponse = function (parsedOutput, context) { return __awaiter(void 0, void 0, void 0, function () {
    var body, deserialized, exception;
    return __generator(this, function (_a) {
        body = parsedOutput.body;
        deserialized = deserializeAws_json1_1InternalException(body, context);
        exception = new InternalException(__assign({ $metadata: deserializeMetadata(parsedOutput) }, deserialized));
        return [2, __decorateServiceException(exception, body)];
    });
}); };
var deserializeAws_json1_1InvalidRequestExceptionResponse = function (parsedOutput, context) { return __awaiter(void 0, void 0, void 0, function () {
    var body, deserialized, exception;
    return __generator(this, function (_a) {
        body = parsedOutput.body;
        deserialized = deserializeAws_json1_1InvalidRequestException(body, context);
        exception = new InvalidRequestException(__assign({ $metadata: deserializeMetadata(parsedOutput) }, deserialized));
        return [2, __decorateServiceException(exception, body)];
    });
}); };
var serializeAws_json1_1AgentArnList = function (input, context) {
    return input
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return entry;
    });
};
var serializeAws_json1_1CancelTaskExecutionRequest = function (input, context) {
    return __assign({}, (input.TaskExecutionArn !== undefined &&
        input.TaskExecutionArn !== null && { TaskExecutionArn: input.TaskExecutionArn }));
};
var serializeAws_json1_1CreateAgentRequest = function (input, context) {
    return __assign(__assign(__assign(__assign(__assign(__assign({}, (input.ActivationKey !== undefined && input.ActivationKey !== null && { ActivationKey: input.ActivationKey })), (input.AgentName !== undefined && input.AgentName !== null && { AgentName: input.AgentName })), (input.SecurityGroupArns !== undefined &&
        input.SecurityGroupArns !== null && {
        SecurityGroupArns: serializeAws_json1_1PLSecurityGroupArnList(input.SecurityGroupArns, context),
    })), (input.SubnetArns !== undefined &&
        input.SubnetArns !== null && { SubnetArns: serializeAws_json1_1PLSubnetArnList(input.SubnetArns, context) })), (input.Tags !== undefined &&
        input.Tags !== null && { Tags: serializeAws_json1_1InputTagList(input.Tags, context) })), (input.VpcEndpointId !== undefined && input.VpcEndpointId !== null && { VpcEndpointId: input.VpcEndpointId }));
};
var serializeAws_json1_1CreateLocationEfsRequest = function (input, context) {
    return __assign(__assign(__assign(__assign({}, (input.Ec2Config !== undefined &&
        input.Ec2Config !== null && { Ec2Config: serializeAws_json1_1Ec2Config(input.Ec2Config, context) })), (input.EfsFilesystemArn !== undefined &&
        input.EfsFilesystemArn !== null && { EfsFilesystemArn: input.EfsFilesystemArn })), (input.Subdirectory !== undefined && input.Subdirectory !== null && { Subdirectory: input.Subdirectory })), (input.Tags !== undefined &&
        input.Tags !== null && { Tags: serializeAws_json1_1InputTagList(input.Tags, context) }));
};
var serializeAws_json1_1CreateLocationFsxLustreRequest = function (input, context) {
    return __assign(__assign(__assign(__assign({}, (input.FsxFilesystemArn !== undefined &&
        input.FsxFilesystemArn !== null && { FsxFilesystemArn: input.FsxFilesystemArn })), (input.SecurityGroupArns !== undefined &&
        input.SecurityGroupArns !== null && {
        SecurityGroupArns: serializeAws_json1_1Ec2SecurityGroupArnList(input.SecurityGroupArns, context),
    })), (input.Subdirectory !== undefined && input.Subdirectory !== null && { Subdirectory: input.Subdirectory })), (input.Tags !== undefined &&
        input.Tags !== null && { Tags: serializeAws_json1_1InputTagList(input.Tags, context) }));
};
var serializeAws_json1_1CreateLocationFsxOpenZfsRequest = function (input, context) {
    return __assign(__assign(__assign(__assign(__assign({}, (input.FsxFilesystemArn !== undefined &&
        input.FsxFilesystemArn !== null && { FsxFilesystemArn: input.FsxFilesystemArn })), (input.Protocol !== undefined &&
        input.Protocol !== null && { Protocol: serializeAws_json1_1FsxProtocol(input.Protocol, context) })), (input.SecurityGroupArns !== undefined &&
        input.SecurityGroupArns !== null && {
        SecurityGroupArns: serializeAws_json1_1Ec2SecurityGroupArnList(input.SecurityGroupArns, context),
    })), (input.Subdirectory !== undefined && input.Subdirectory !== null && { Subdirectory: input.Subdirectory })), (input.Tags !== undefined &&
        input.Tags !== null && { Tags: serializeAws_json1_1InputTagList(input.Tags, context) }));
};
var serializeAws_json1_1CreateLocationFsxWindowsRequest = function (input, context) {
    return __assign(__assign(__assign(__assign(__assign(__assign(__assign({}, (input.Domain !== undefined && input.Domain !== null && { Domain: input.Domain })), (input.FsxFilesystemArn !== undefined &&
        input.FsxFilesystemArn !== null && { FsxFilesystemArn: input.FsxFilesystemArn })), (input.Password !== undefined && input.Password !== null && { Password: input.Password })), (input.SecurityGroupArns !== undefined &&
        input.SecurityGroupArns !== null && {
        SecurityGroupArns: serializeAws_json1_1Ec2SecurityGroupArnList(input.SecurityGroupArns, context),
    })), (input.Subdirectory !== undefined && input.Subdirectory !== null && { Subdirectory: input.Subdirectory })), (input.Tags !== undefined &&
        input.Tags !== null && { Tags: serializeAws_json1_1InputTagList(input.Tags, context) })), (input.User !== undefined && input.User !== null && { User: input.User }));
};
var serializeAws_json1_1CreateLocationHdfsRequest = function (input, context) {
    return __assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign({}, (input.AgentArns !== undefined &&
        input.AgentArns !== null && { AgentArns: serializeAws_json1_1AgentArnList(input.AgentArns, context) })), (input.AuthenticationType !== undefined &&
        input.AuthenticationType !== null && { AuthenticationType: input.AuthenticationType })), (input.BlockSize !== undefined && input.BlockSize !== null && { BlockSize: input.BlockSize })), (input.KerberosKeytab !== undefined &&
        input.KerberosKeytab !== null && { KerberosKeytab: context.base64Encoder(input.KerberosKeytab) })), (input.KerberosKrb5Conf !== undefined &&
        input.KerberosKrb5Conf !== null && { KerberosKrb5Conf: context.base64Encoder(input.KerberosKrb5Conf) })), (input.KerberosPrincipal !== undefined &&
        input.KerberosPrincipal !== null && { KerberosPrincipal: input.KerberosPrincipal })), (input.KmsKeyProviderUri !== undefined &&
        input.KmsKeyProviderUri !== null && { KmsKeyProviderUri: input.KmsKeyProviderUri })), (input.NameNodes !== undefined &&
        input.NameNodes !== null && { NameNodes: serializeAws_json1_1HdfsNameNodeList(input.NameNodes, context) })), (input.QopConfiguration !== undefined &&
        input.QopConfiguration !== null && {
        QopConfiguration: serializeAws_json1_1QopConfiguration(input.QopConfiguration, context),
    })), (input.ReplicationFactor !== undefined &&
        input.ReplicationFactor !== null && { ReplicationFactor: input.ReplicationFactor })), (input.SimpleUser !== undefined && input.SimpleUser !== null && { SimpleUser: input.SimpleUser })), (input.Subdirectory !== undefined && input.Subdirectory !== null && { Subdirectory: input.Subdirectory })), (input.Tags !== undefined &&
        input.Tags !== null && { Tags: serializeAws_json1_1InputTagList(input.Tags, context) }));
};
var serializeAws_json1_1CreateLocationNfsRequest = function (input, context) {
    return __assign(__assign(__assign(__assign(__assign({}, (input.MountOptions !== undefined &&
        input.MountOptions !== null && {
        MountOptions: serializeAws_json1_1NfsMountOptions(input.MountOptions, context),
    })), (input.OnPremConfig !== undefined &&
        input.OnPremConfig !== null && { OnPremConfig: serializeAws_json1_1OnPremConfig(input.OnPremConfig, context) })), (input.ServerHostname !== undefined &&
        input.ServerHostname !== null && { ServerHostname: input.ServerHostname })), (input.Subdirectory !== undefined && input.Subdirectory !== null && { Subdirectory: input.Subdirectory })), (input.Tags !== undefined &&
        input.Tags !== null && { Tags: serializeAws_json1_1InputTagList(input.Tags, context) }));
};
var serializeAws_json1_1CreateLocationObjectStorageRequest = function (input, context) {
    return __assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign({}, (input.AccessKey !== undefined && input.AccessKey !== null && { AccessKey: input.AccessKey })), (input.AgentArns !== undefined &&
        input.AgentArns !== null && { AgentArns: serializeAws_json1_1AgentArnList(input.AgentArns, context) })), (input.BucketName !== undefined && input.BucketName !== null && { BucketName: input.BucketName })), (input.SecretKey !== undefined && input.SecretKey !== null && { SecretKey: input.SecretKey })), (input.ServerHostname !== undefined &&
        input.ServerHostname !== null && { ServerHostname: input.ServerHostname })), (input.ServerPort !== undefined && input.ServerPort !== null && { ServerPort: input.ServerPort })), (input.ServerProtocol !== undefined &&
        input.ServerProtocol !== null && { ServerProtocol: input.ServerProtocol })), (input.Subdirectory !== undefined && input.Subdirectory !== null && { Subdirectory: input.Subdirectory })), (input.Tags !== undefined &&
        input.Tags !== null && { Tags: serializeAws_json1_1InputTagList(input.Tags, context) }));
};
var serializeAws_json1_1CreateLocationS3Request = function (input, context) {
    return __assign(__assign(__assign(__assign(__assign(__assign({}, (input.AgentArns !== undefined &&
        input.AgentArns !== null && { AgentArns: serializeAws_json1_1AgentArnList(input.AgentArns, context) })), (input.S3BucketArn !== undefined && input.S3BucketArn !== null && { S3BucketArn: input.S3BucketArn })), (input.S3Config !== undefined &&
        input.S3Config !== null && { S3Config: serializeAws_json1_1S3Config(input.S3Config, context) })), (input.S3StorageClass !== undefined &&
        input.S3StorageClass !== null && { S3StorageClass: input.S3StorageClass })), (input.Subdirectory !== undefined && input.Subdirectory !== null && { Subdirectory: input.Subdirectory })), (input.Tags !== undefined &&
        input.Tags !== null && { Tags: serializeAws_json1_1InputTagList(input.Tags, context) }));
};
var serializeAws_json1_1CreateLocationSmbRequest = function (input, context) {
    return __assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign({}, (input.AgentArns !== undefined &&
        input.AgentArns !== null && { AgentArns: serializeAws_json1_1AgentArnList(input.AgentArns, context) })), (input.Domain !== undefined && input.Domain !== null && { Domain: input.Domain })), (input.MountOptions !== undefined &&
        input.MountOptions !== null && {
        MountOptions: serializeAws_json1_1SmbMountOptions(input.MountOptions, context),
    })), (input.Password !== undefined && input.Password !== null && { Password: input.Password })), (input.ServerHostname !== undefined &&
        input.ServerHostname !== null && { ServerHostname: input.ServerHostname })), (input.Subdirectory !== undefined && input.Subdirectory !== null && { Subdirectory: input.Subdirectory })), (input.Tags !== undefined &&
        input.Tags !== null && { Tags: serializeAws_json1_1InputTagList(input.Tags, context) })), (input.User !== undefined && input.User !== null && { User: input.User }));
};
var serializeAws_json1_1CreateTaskRequest = function (input, context) {
    return __assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign({}, (input.CloudWatchLogGroupArn !== undefined &&
        input.CloudWatchLogGroupArn !== null && { CloudWatchLogGroupArn: input.CloudWatchLogGroupArn })), (input.DestinationLocationArn !== undefined &&
        input.DestinationLocationArn !== null && { DestinationLocationArn: input.DestinationLocationArn })), (input.Excludes !== undefined &&
        input.Excludes !== null && { Excludes: serializeAws_json1_1FilterList(input.Excludes, context) })), (input.Includes !== undefined &&
        input.Includes !== null && { Includes: serializeAws_json1_1FilterList(input.Includes, context) })), (input.Name !== undefined && input.Name !== null && { Name: input.Name })), (input.Options !== undefined &&
        input.Options !== null && { Options: serializeAws_json1_1Options(input.Options, context) })), (input.Schedule !== undefined &&
        input.Schedule !== null && { Schedule: serializeAws_json1_1TaskSchedule(input.Schedule, context) })), (input.SourceLocationArn !== undefined &&
        input.SourceLocationArn !== null && { SourceLocationArn: input.SourceLocationArn })), (input.Tags !== undefined &&
        input.Tags !== null && { Tags: serializeAws_json1_1InputTagList(input.Tags, context) }));
};
var serializeAws_json1_1DeleteAgentRequest = function (input, context) {
    return __assign({}, (input.AgentArn !== undefined && input.AgentArn !== null && { AgentArn: input.AgentArn }));
};
var serializeAws_json1_1DeleteLocationRequest = function (input, context) {
    return __assign({}, (input.LocationArn !== undefined && input.LocationArn !== null && { LocationArn: input.LocationArn }));
};
var serializeAws_json1_1DeleteTaskRequest = function (input, context) {
    return __assign({}, (input.TaskArn !== undefined && input.TaskArn !== null && { TaskArn: input.TaskArn }));
};
var serializeAws_json1_1DescribeAgentRequest = function (input, context) {
    return __assign({}, (input.AgentArn !== undefined && input.AgentArn !== null && { AgentArn: input.AgentArn }));
};
var serializeAws_json1_1DescribeLocationEfsRequest = function (input, context) {
    return __assign({}, (input.LocationArn !== undefined && input.LocationArn !== null && { LocationArn: input.LocationArn }));
};
var serializeAws_json1_1DescribeLocationFsxLustreRequest = function (input, context) {
    return __assign({}, (input.LocationArn !== undefined && input.LocationArn !== null && { LocationArn: input.LocationArn }));
};
var serializeAws_json1_1DescribeLocationFsxOpenZfsRequest = function (input, context) {
    return __assign({}, (input.LocationArn !== undefined && input.LocationArn !== null && { LocationArn: input.LocationArn }));
};
var serializeAws_json1_1DescribeLocationFsxWindowsRequest = function (input, context) {
    return __assign({}, (input.LocationArn !== undefined && input.LocationArn !== null && { LocationArn: input.LocationArn }));
};
var serializeAws_json1_1DescribeLocationHdfsRequest = function (input, context) {
    return __assign({}, (input.LocationArn !== undefined && input.LocationArn !== null && { LocationArn: input.LocationArn }));
};
var serializeAws_json1_1DescribeLocationNfsRequest = function (input, context) {
    return __assign({}, (input.LocationArn !== undefined && input.LocationArn !== null && { LocationArn: input.LocationArn }));
};
var serializeAws_json1_1DescribeLocationObjectStorageRequest = function (input, context) {
    return __assign({}, (input.LocationArn !== undefined && input.LocationArn !== null && { LocationArn: input.LocationArn }));
};
var serializeAws_json1_1DescribeLocationS3Request = function (input, context) {
    return __assign({}, (input.LocationArn !== undefined && input.LocationArn !== null && { LocationArn: input.LocationArn }));
};
var serializeAws_json1_1DescribeLocationSmbRequest = function (input, context) {
    return __assign({}, (input.LocationArn !== undefined && input.LocationArn !== null && { LocationArn: input.LocationArn }));
};
var serializeAws_json1_1DescribeTaskExecutionRequest = function (input, context) {
    return __assign({}, (input.TaskExecutionArn !== undefined &&
        input.TaskExecutionArn !== null && { TaskExecutionArn: input.TaskExecutionArn }));
};
var serializeAws_json1_1DescribeTaskRequest = function (input, context) {
    return __assign({}, (input.TaskArn !== undefined && input.TaskArn !== null && { TaskArn: input.TaskArn }));
};
var serializeAws_json1_1Ec2Config = function (input, context) {
    return __assign(__assign({}, (input.SecurityGroupArns !== undefined &&
        input.SecurityGroupArns !== null && {
        SecurityGroupArns: serializeAws_json1_1Ec2SecurityGroupArnList(input.SecurityGroupArns, context),
    })), (input.SubnetArn !== undefined && input.SubnetArn !== null && { SubnetArn: input.SubnetArn }));
};
var serializeAws_json1_1Ec2SecurityGroupArnList = function (input, context) {
    return input
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return entry;
    });
};
var serializeAws_json1_1FilterList = function (input, context) {
    return input
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return serializeAws_json1_1FilterRule(entry, context);
    });
};
var serializeAws_json1_1FilterRule = function (input, context) {
    return __assign(__assign({}, (input.FilterType !== undefined && input.FilterType !== null && { FilterType: input.FilterType })), (input.Value !== undefined && input.Value !== null && { Value: input.Value }));
};
var serializeAws_json1_1FilterValues = function (input, context) {
    return input
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return entry;
    });
};
var serializeAws_json1_1FsxProtocol = function (input, context) {
    return __assign({}, (input.NFS !== undefined &&
        input.NFS !== null && { NFS: serializeAws_json1_1FsxProtocolNfs(input.NFS, context) }));
};
var serializeAws_json1_1FsxProtocolNfs = function (input, context) {
    return __assign({}, (input.MountOptions !== undefined &&
        input.MountOptions !== null && {
        MountOptions: serializeAws_json1_1NfsMountOptions(input.MountOptions, context),
    }));
};
var serializeAws_json1_1HdfsNameNode = function (input, context) {
    return __assign(__assign({}, (input.Hostname !== undefined && input.Hostname !== null && { Hostname: input.Hostname })), (input.Port !== undefined && input.Port !== null && { Port: input.Port }));
};
var serializeAws_json1_1HdfsNameNodeList = function (input, context) {
    return input
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return serializeAws_json1_1HdfsNameNode(entry, context);
    });
};
var serializeAws_json1_1InputTagList = function (input, context) {
    return input
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return serializeAws_json1_1TagListEntry(entry, context);
    });
};
var serializeAws_json1_1ListAgentsRequest = function (input, context) {
    return __assign(__assign({}, (input.MaxResults !== undefined && input.MaxResults !== null && { MaxResults: input.MaxResults })), (input.NextToken !== undefined && input.NextToken !== null && { NextToken: input.NextToken }));
};
var serializeAws_json1_1ListLocationsRequest = function (input, context) {
    return __assign(__assign(__assign({}, (input.Filters !== undefined &&
        input.Filters !== null && { Filters: serializeAws_json1_1LocationFilters(input.Filters, context) })), (input.MaxResults !== undefined && input.MaxResults !== null && { MaxResults: input.MaxResults })), (input.NextToken !== undefined && input.NextToken !== null && { NextToken: input.NextToken }));
};
var serializeAws_json1_1ListTagsForResourceRequest = function (input, context) {
    return __assign(__assign(__assign({}, (input.MaxResults !== undefined && input.MaxResults !== null && { MaxResults: input.MaxResults })), (input.NextToken !== undefined && input.NextToken !== null && { NextToken: input.NextToken })), (input.ResourceArn !== undefined && input.ResourceArn !== null && { ResourceArn: input.ResourceArn }));
};
var serializeAws_json1_1ListTaskExecutionsRequest = function (input, context) {
    return __assign(__assign(__assign({}, (input.MaxResults !== undefined && input.MaxResults !== null && { MaxResults: input.MaxResults })), (input.NextToken !== undefined && input.NextToken !== null && { NextToken: input.NextToken })), (input.TaskArn !== undefined && input.TaskArn !== null && { TaskArn: input.TaskArn }));
};
var serializeAws_json1_1ListTasksRequest = function (input, context) {
    return __assign(__assign(__assign({}, (input.Filters !== undefined &&
        input.Filters !== null && { Filters: serializeAws_json1_1TaskFilters(input.Filters, context) })), (input.MaxResults !== undefined && input.MaxResults !== null && { MaxResults: input.MaxResults })), (input.NextToken !== undefined && input.NextToken !== null && { NextToken: input.NextToken }));
};
var serializeAws_json1_1LocationFilter = function (input, context) {
    return __assign(__assign(__assign({}, (input.Name !== undefined && input.Name !== null && { Name: input.Name })), (input.Operator !== undefined && input.Operator !== null && { Operator: input.Operator })), (input.Values !== undefined &&
        input.Values !== null && { Values: serializeAws_json1_1FilterValues(input.Values, context) }));
};
var serializeAws_json1_1LocationFilters = function (input, context) {
    return input
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return serializeAws_json1_1LocationFilter(entry, context);
    });
};
var serializeAws_json1_1NfsMountOptions = function (input, context) {
    return __assign({}, (input.Version !== undefined && input.Version !== null && { Version: input.Version }));
};
var serializeAws_json1_1OnPremConfig = function (input, context) {
    return __assign({}, (input.AgentArns !== undefined &&
        input.AgentArns !== null && { AgentArns: serializeAws_json1_1AgentArnList(input.AgentArns, context) }));
};
var serializeAws_json1_1Options = function (input, context) {
    return __assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign({}, (input.Atime !== undefined && input.Atime !== null && { Atime: input.Atime })), (input.BytesPerSecond !== undefined &&
        input.BytesPerSecond !== null && { BytesPerSecond: input.BytesPerSecond })), (input.Gid !== undefined && input.Gid !== null && { Gid: input.Gid })), (input.LogLevel !== undefined && input.LogLevel !== null && { LogLevel: input.LogLevel })), (input.Mtime !== undefined && input.Mtime !== null && { Mtime: input.Mtime })), (input.OverwriteMode !== undefined && input.OverwriteMode !== null && { OverwriteMode: input.OverwriteMode })), (input.PosixPermissions !== undefined &&
        input.PosixPermissions !== null && { PosixPermissions: input.PosixPermissions })), (input.PreserveDeletedFiles !== undefined &&
        input.PreserveDeletedFiles !== null && { PreserveDeletedFiles: input.PreserveDeletedFiles })), (input.PreserveDevices !== undefined &&
        input.PreserveDevices !== null && { PreserveDevices: input.PreserveDevices })), (input.SecurityDescriptorCopyFlags !== undefined &&
        input.SecurityDescriptorCopyFlags !== null && { SecurityDescriptorCopyFlags: input.SecurityDescriptorCopyFlags })), (input.TaskQueueing !== undefined && input.TaskQueueing !== null && { TaskQueueing: input.TaskQueueing })), (input.TransferMode !== undefined && input.TransferMode !== null && { TransferMode: input.TransferMode })), (input.Uid !== undefined && input.Uid !== null && { Uid: input.Uid })), (input.VerifyMode !== undefined && input.VerifyMode !== null && { VerifyMode: input.VerifyMode }));
};
var serializeAws_json1_1PLSecurityGroupArnList = function (input, context) {
    return input
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return entry;
    });
};
var serializeAws_json1_1PLSubnetArnList = function (input, context) {
    return input
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return entry;
    });
};
var serializeAws_json1_1QopConfiguration = function (input, context) {
    return __assign(__assign({}, (input.DataTransferProtection !== undefined &&
        input.DataTransferProtection !== null && { DataTransferProtection: input.DataTransferProtection })), (input.RpcProtection !== undefined && input.RpcProtection !== null && { RpcProtection: input.RpcProtection }));
};
var serializeAws_json1_1S3Config = function (input, context) {
    return __assign({}, (input.BucketAccessRoleArn !== undefined &&
        input.BucketAccessRoleArn !== null && { BucketAccessRoleArn: input.BucketAccessRoleArn }));
};
var serializeAws_json1_1SmbMountOptions = function (input, context) {
    return __assign({}, (input.Version !== undefined && input.Version !== null && { Version: input.Version }));
};
var serializeAws_json1_1StartTaskExecutionRequest = function (input, context) {
    return __assign(__assign(__assign(__assign({}, (input.Excludes !== undefined &&
        input.Excludes !== null && { Excludes: serializeAws_json1_1FilterList(input.Excludes, context) })), (input.Includes !== undefined &&
        input.Includes !== null && { Includes: serializeAws_json1_1FilterList(input.Includes, context) })), (input.OverrideOptions !== undefined &&
        input.OverrideOptions !== null && {
        OverrideOptions: serializeAws_json1_1Options(input.OverrideOptions, context),
    })), (input.TaskArn !== undefined && input.TaskArn !== null && { TaskArn: input.TaskArn }));
};
var serializeAws_json1_1TagKeyList = function (input, context) {
    return input
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return entry;
    });
};
var serializeAws_json1_1TagListEntry = function (input, context) {
    return __assign(__assign({}, (input.Key !== undefined && input.Key !== null && { Key: input.Key })), (input.Value !== undefined && input.Value !== null && { Value: input.Value }));
};
var serializeAws_json1_1TagResourceRequest = function (input, context) {
    return __assign(__assign({}, (input.ResourceArn !== undefined && input.ResourceArn !== null && { ResourceArn: input.ResourceArn })), (input.Tags !== undefined &&
        input.Tags !== null && { Tags: serializeAws_json1_1InputTagList(input.Tags, context) }));
};
var serializeAws_json1_1TaskFilter = function (input, context) {
    return __assign(__assign(__assign({}, (input.Name !== undefined && input.Name !== null && { Name: input.Name })), (input.Operator !== undefined && input.Operator !== null && { Operator: input.Operator })), (input.Values !== undefined &&
        input.Values !== null && { Values: serializeAws_json1_1FilterValues(input.Values, context) }));
};
var serializeAws_json1_1TaskFilters = function (input, context) {
    return input
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return serializeAws_json1_1TaskFilter(entry, context);
    });
};
var serializeAws_json1_1TaskSchedule = function (input, context) {
    return __assign({}, (input.ScheduleExpression !== undefined &&
        input.ScheduleExpression !== null && { ScheduleExpression: input.ScheduleExpression }));
};
var serializeAws_json1_1UntagResourceRequest = function (input, context) {
    return __assign(__assign({}, (input.Keys !== undefined &&
        input.Keys !== null && { Keys: serializeAws_json1_1TagKeyList(input.Keys, context) })), (input.ResourceArn !== undefined && input.ResourceArn !== null && { ResourceArn: input.ResourceArn }));
};
var serializeAws_json1_1UpdateAgentRequest = function (input, context) {
    return __assign(__assign({}, (input.AgentArn !== undefined && input.AgentArn !== null && { AgentArn: input.AgentArn })), (input.Name !== undefined && input.Name !== null && { Name: input.Name }));
};
var serializeAws_json1_1UpdateLocationHdfsRequest = function (input, context) {
    return __assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign({}, (input.AgentArns !== undefined &&
        input.AgentArns !== null && { AgentArns: serializeAws_json1_1AgentArnList(input.AgentArns, context) })), (input.AuthenticationType !== undefined &&
        input.AuthenticationType !== null && { AuthenticationType: input.AuthenticationType })), (input.BlockSize !== undefined && input.BlockSize !== null && { BlockSize: input.BlockSize })), (input.KerberosKeytab !== undefined &&
        input.KerberosKeytab !== null && { KerberosKeytab: context.base64Encoder(input.KerberosKeytab) })), (input.KerberosKrb5Conf !== undefined &&
        input.KerberosKrb5Conf !== null && { KerberosKrb5Conf: context.base64Encoder(input.KerberosKrb5Conf) })), (input.KerberosPrincipal !== undefined &&
        input.KerberosPrincipal !== null && { KerberosPrincipal: input.KerberosPrincipal })), (input.KmsKeyProviderUri !== undefined &&
        input.KmsKeyProviderUri !== null && { KmsKeyProviderUri: input.KmsKeyProviderUri })), (input.LocationArn !== undefined && input.LocationArn !== null && { LocationArn: input.LocationArn })), (input.NameNodes !== undefined &&
        input.NameNodes !== null && { NameNodes: serializeAws_json1_1HdfsNameNodeList(input.NameNodes, context) })), (input.QopConfiguration !== undefined &&
        input.QopConfiguration !== null && {
        QopConfiguration: serializeAws_json1_1QopConfiguration(input.QopConfiguration, context),
    })), (input.ReplicationFactor !== undefined &&
        input.ReplicationFactor !== null && { ReplicationFactor: input.ReplicationFactor })), (input.SimpleUser !== undefined && input.SimpleUser !== null && { SimpleUser: input.SimpleUser })), (input.Subdirectory !== undefined && input.Subdirectory !== null && { Subdirectory: input.Subdirectory }));
};
var serializeAws_json1_1UpdateLocationNfsRequest = function (input, context) {
    return __assign(__assign(__assign(__assign({}, (input.LocationArn !== undefined && input.LocationArn !== null && { LocationArn: input.LocationArn })), (input.MountOptions !== undefined &&
        input.MountOptions !== null && {
        MountOptions: serializeAws_json1_1NfsMountOptions(input.MountOptions, context),
    })), (input.OnPremConfig !== undefined &&
        input.OnPremConfig !== null && { OnPremConfig: serializeAws_json1_1OnPremConfig(input.OnPremConfig, context) })), (input.Subdirectory !== undefined && input.Subdirectory !== null && { Subdirectory: input.Subdirectory }));
};
var serializeAws_json1_1UpdateLocationObjectStorageRequest = function (input, context) {
    return __assign(__assign(__assign(__assign(__assign(__assign(__assign({}, (input.AccessKey !== undefined && input.AccessKey !== null && { AccessKey: input.AccessKey })), (input.AgentArns !== undefined &&
        input.AgentArns !== null && { AgentArns: serializeAws_json1_1AgentArnList(input.AgentArns, context) })), (input.LocationArn !== undefined && input.LocationArn !== null && { LocationArn: input.LocationArn })), (input.SecretKey !== undefined && input.SecretKey !== null && { SecretKey: input.SecretKey })), (input.ServerPort !== undefined && input.ServerPort !== null && { ServerPort: input.ServerPort })), (input.ServerProtocol !== undefined &&
        input.ServerProtocol !== null && { ServerProtocol: input.ServerProtocol })), (input.Subdirectory !== undefined && input.Subdirectory !== null && { Subdirectory: input.Subdirectory }));
};
var serializeAws_json1_1UpdateLocationSmbRequest = function (input, context) {
    return __assign(__assign(__assign(__assign(__assign(__assign(__assign({}, (input.AgentArns !== undefined &&
        input.AgentArns !== null && { AgentArns: serializeAws_json1_1AgentArnList(input.AgentArns, context) })), (input.Domain !== undefined && input.Domain !== null && { Domain: input.Domain })), (input.LocationArn !== undefined && input.LocationArn !== null && { LocationArn: input.LocationArn })), (input.MountOptions !== undefined &&
        input.MountOptions !== null && {
        MountOptions: serializeAws_json1_1SmbMountOptions(input.MountOptions, context),
    })), (input.Password !== undefined && input.Password !== null && { Password: input.Password })), (input.Subdirectory !== undefined && input.Subdirectory !== null && { Subdirectory: input.Subdirectory })), (input.User !== undefined && input.User !== null && { User: input.User }));
};
var serializeAws_json1_1UpdateTaskExecutionRequest = function (input, context) {
    return __assign(__assign({}, (input.Options !== undefined &&
        input.Options !== null && { Options: serializeAws_json1_1Options(input.Options, context) })), (input.TaskExecutionArn !== undefined &&
        input.TaskExecutionArn !== null && { TaskExecutionArn: input.TaskExecutionArn }));
};
var serializeAws_json1_1UpdateTaskRequest = function (input, context) {
    return __assign(__assign(__assign(__assign(__assign(__assign(__assign({}, (input.CloudWatchLogGroupArn !== undefined &&
        input.CloudWatchLogGroupArn !== null && { CloudWatchLogGroupArn: input.CloudWatchLogGroupArn })), (input.Excludes !== undefined &&
        input.Excludes !== null && { Excludes: serializeAws_json1_1FilterList(input.Excludes, context) })), (input.Includes !== undefined &&
        input.Includes !== null && { Includes: serializeAws_json1_1FilterList(input.Includes, context) })), (input.Name !== undefined && input.Name !== null && { Name: input.Name })), (input.Options !== undefined &&
        input.Options !== null && { Options: serializeAws_json1_1Options(input.Options, context) })), (input.Schedule !== undefined &&
        input.Schedule !== null && { Schedule: serializeAws_json1_1TaskSchedule(input.Schedule, context) })), (input.TaskArn !== undefined && input.TaskArn !== null && { TaskArn: input.TaskArn }));
};
var deserializeAws_json1_1AgentArnList = function (output, context) {
    var retVal = (output || [])
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return __expectString(entry);
    });
    return retVal;
};
var deserializeAws_json1_1AgentList = function (output, context) {
    var retVal = (output || [])
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1AgentListEntry(entry, context);
    });
    return retVal;
};
var deserializeAws_json1_1AgentListEntry = function (output, context) {
    return {
        AgentArn: __expectString(output.AgentArn),
        Name: __expectString(output.Name),
        Status: __expectString(output.Status),
    };
};
var deserializeAws_json1_1CancelTaskExecutionResponse = function (output, context) {
    return {};
};
var deserializeAws_json1_1CreateAgentResponse = function (output, context) {
    return {
        AgentArn: __expectString(output.AgentArn),
    };
};
var deserializeAws_json1_1CreateLocationEfsResponse = function (output, context) {
    return {
        LocationArn: __expectString(output.LocationArn),
    };
};
var deserializeAws_json1_1CreateLocationFsxLustreResponse = function (output, context) {
    return {
        LocationArn: __expectString(output.LocationArn),
    };
};
var deserializeAws_json1_1CreateLocationFsxOpenZfsResponse = function (output, context) {
    return {
        LocationArn: __expectString(output.LocationArn),
    };
};
var deserializeAws_json1_1CreateLocationFsxWindowsResponse = function (output, context) {
    return {
        LocationArn: __expectString(output.LocationArn),
    };
};
var deserializeAws_json1_1CreateLocationHdfsResponse = function (output, context) {
    return {
        LocationArn: __expectString(output.LocationArn),
    };
};
var deserializeAws_json1_1CreateLocationNfsResponse = function (output, context) {
    return {
        LocationArn: __expectString(output.LocationArn),
    };
};
var deserializeAws_json1_1CreateLocationObjectStorageResponse = function (output, context) {
    return {
        LocationArn: __expectString(output.LocationArn),
    };
};
var deserializeAws_json1_1CreateLocationS3Response = function (output, context) {
    return {
        LocationArn: __expectString(output.LocationArn),
    };
};
var deserializeAws_json1_1CreateLocationSmbResponse = function (output, context) {
    return {
        LocationArn: __expectString(output.LocationArn),
    };
};
var deserializeAws_json1_1CreateTaskResponse = function (output, context) {
    return {
        TaskArn: __expectString(output.TaskArn),
    };
};
var deserializeAws_json1_1DeleteAgentResponse = function (output, context) {
    return {};
};
var deserializeAws_json1_1DeleteLocationResponse = function (output, context) {
    return {};
};
var deserializeAws_json1_1DeleteTaskResponse = function (output, context) {
    return {};
};
var deserializeAws_json1_1DescribeAgentResponse = function (output, context) {
    return {
        AgentArn: __expectString(output.AgentArn),
        CreationTime: output.CreationTime !== undefined && output.CreationTime !== null
            ? __expectNonNull(__parseEpochTimestamp(__expectNumber(output.CreationTime)))
            : undefined,
        EndpointType: __expectString(output.EndpointType),
        LastConnectionTime: output.LastConnectionTime !== undefined && output.LastConnectionTime !== null
            ? __expectNonNull(__parseEpochTimestamp(__expectNumber(output.LastConnectionTime)))
            : undefined,
        Name: __expectString(output.Name),
        PrivateLinkConfig: output.PrivateLinkConfig !== undefined && output.PrivateLinkConfig !== null
            ? deserializeAws_json1_1PrivateLinkConfig(output.PrivateLinkConfig, context)
            : undefined,
        Status: __expectString(output.Status),
    };
};
var deserializeAws_json1_1DescribeLocationEfsResponse = function (output, context) {
    return {
        CreationTime: output.CreationTime !== undefined && output.CreationTime !== null
            ? __expectNonNull(__parseEpochTimestamp(__expectNumber(output.CreationTime)))
            : undefined,
        Ec2Config: output.Ec2Config !== undefined && output.Ec2Config !== null
            ? deserializeAws_json1_1Ec2Config(output.Ec2Config, context)
            : undefined,
        LocationArn: __expectString(output.LocationArn),
        LocationUri: __expectString(output.LocationUri),
    };
};
var deserializeAws_json1_1DescribeLocationFsxLustreResponse = function (output, context) {
    return {
        CreationTime: output.CreationTime !== undefined && output.CreationTime !== null
            ? __expectNonNull(__parseEpochTimestamp(__expectNumber(output.CreationTime)))
            : undefined,
        LocationArn: __expectString(output.LocationArn),
        LocationUri: __expectString(output.LocationUri),
        SecurityGroupArns: output.SecurityGroupArns !== undefined && output.SecurityGroupArns !== null
            ? deserializeAws_json1_1Ec2SecurityGroupArnList(output.SecurityGroupArns, context)
            : undefined,
    };
};
var deserializeAws_json1_1DescribeLocationFsxOpenZfsResponse = function (output, context) {
    return {
        CreationTime: output.CreationTime !== undefined && output.CreationTime !== null
            ? __expectNonNull(__parseEpochTimestamp(__expectNumber(output.CreationTime)))
            : undefined,
        LocationArn: __expectString(output.LocationArn),
        LocationUri: __expectString(output.LocationUri),
        Protocol: output.Protocol !== undefined && output.Protocol !== null
            ? deserializeAws_json1_1FsxProtocol(output.Protocol, context)
            : undefined,
        SecurityGroupArns: output.SecurityGroupArns !== undefined && output.SecurityGroupArns !== null
            ? deserializeAws_json1_1Ec2SecurityGroupArnList(output.SecurityGroupArns, context)
            : undefined,
    };
};
var deserializeAws_json1_1DescribeLocationFsxWindowsResponse = function (output, context) {
    return {
        CreationTime: output.CreationTime !== undefined && output.CreationTime !== null
            ? __expectNonNull(__parseEpochTimestamp(__expectNumber(output.CreationTime)))
            : undefined,
        Domain: __expectString(output.Domain),
        LocationArn: __expectString(output.LocationArn),
        LocationUri: __expectString(output.LocationUri),
        SecurityGroupArns: output.SecurityGroupArns !== undefined && output.SecurityGroupArns !== null
            ? deserializeAws_json1_1Ec2SecurityGroupArnList(output.SecurityGroupArns, context)
            : undefined,
        User: __expectString(output.User),
    };
};
var deserializeAws_json1_1DescribeLocationHdfsResponse = function (output, context) {
    return {
        AgentArns: output.AgentArns !== undefined && output.AgentArns !== null
            ? deserializeAws_json1_1AgentArnList(output.AgentArns, context)
            : undefined,
        AuthenticationType: __expectString(output.AuthenticationType),
        BlockSize: __expectInt32(output.BlockSize),
        CreationTime: output.CreationTime !== undefined && output.CreationTime !== null
            ? __expectNonNull(__parseEpochTimestamp(__expectNumber(output.CreationTime)))
            : undefined,
        KerberosPrincipal: __expectString(output.KerberosPrincipal),
        KmsKeyProviderUri: __expectString(output.KmsKeyProviderUri),
        LocationArn: __expectString(output.LocationArn),
        LocationUri: __expectString(output.LocationUri),
        NameNodes: output.NameNodes !== undefined && output.NameNodes !== null
            ? deserializeAws_json1_1HdfsNameNodeList(output.NameNodes, context)
            : undefined,
        QopConfiguration: output.QopConfiguration !== undefined && output.QopConfiguration !== null
            ? deserializeAws_json1_1QopConfiguration(output.QopConfiguration, context)
            : undefined,
        ReplicationFactor: __expectInt32(output.ReplicationFactor),
        SimpleUser: __expectString(output.SimpleUser),
    };
};
var deserializeAws_json1_1DescribeLocationNfsResponse = function (output, context) {
    return {
        CreationTime: output.CreationTime !== undefined && output.CreationTime !== null
            ? __expectNonNull(__parseEpochTimestamp(__expectNumber(output.CreationTime)))
            : undefined,
        LocationArn: __expectString(output.LocationArn),
        LocationUri: __expectString(output.LocationUri),
        MountOptions: output.MountOptions !== undefined && output.MountOptions !== null
            ? deserializeAws_json1_1NfsMountOptions(output.MountOptions, context)
            : undefined,
        OnPremConfig: output.OnPremConfig !== undefined && output.OnPremConfig !== null
            ? deserializeAws_json1_1OnPremConfig(output.OnPremConfig, context)
            : undefined,
    };
};
var deserializeAws_json1_1DescribeLocationObjectStorageResponse = function (output, context) {
    return {
        AccessKey: __expectString(output.AccessKey),
        AgentArns: output.AgentArns !== undefined && output.AgentArns !== null
            ? deserializeAws_json1_1AgentArnList(output.AgentArns, context)
            : undefined,
        CreationTime: output.CreationTime !== undefined && output.CreationTime !== null
            ? __expectNonNull(__parseEpochTimestamp(__expectNumber(output.CreationTime)))
            : undefined,
        LocationArn: __expectString(output.LocationArn),
        LocationUri: __expectString(output.LocationUri),
        ServerPort: __expectInt32(output.ServerPort),
        ServerProtocol: __expectString(output.ServerProtocol),
    };
};
var deserializeAws_json1_1DescribeLocationS3Response = function (output, context) {
    return {
        AgentArns: output.AgentArns !== undefined && output.AgentArns !== null
            ? deserializeAws_json1_1AgentArnList(output.AgentArns, context)
            : undefined,
        CreationTime: output.CreationTime !== undefined && output.CreationTime !== null
            ? __expectNonNull(__parseEpochTimestamp(__expectNumber(output.CreationTime)))
            : undefined,
        LocationArn: __expectString(output.LocationArn),
        LocationUri: __expectString(output.LocationUri),
        S3Config: output.S3Config !== undefined && output.S3Config !== null
            ? deserializeAws_json1_1S3Config(output.S3Config, context)
            : undefined,
        S3StorageClass: __expectString(output.S3StorageClass),
    };
};
var deserializeAws_json1_1DescribeLocationSmbResponse = function (output, context) {
    return {
        AgentArns: output.AgentArns !== undefined && output.AgentArns !== null
            ? deserializeAws_json1_1AgentArnList(output.AgentArns, context)
            : undefined,
        CreationTime: output.CreationTime !== undefined && output.CreationTime !== null
            ? __expectNonNull(__parseEpochTimestamp(__expectNumber(output.CreationTime)))
            : undefined,
        Domain: __expectString(output.Domain),
        LocationArn: __expectString(output.LocationArn),
        LocationUri: __expectString(output.LocationUri),
        MountOptions: output.MountOptions !== undefined && output.MountOptions !== null
            ? deserializeAws_json1_1SmbMountOptions(output.MountOptions, context)
            : undefined,
        User: __expectString(output.User),
    };
};
var deserializeAws_json1_1DescribeTaskExecutionResponse = function (output, context) {
    return {
        BytesTransferred: __expectLong(output.BytesTransferred),
        BytesWritten: __expectLong(output.BytesWritten),
        EstimatedBytesToTransfer: __expectLong(output.EstimatedBytesToTransfer),
        EstimatedFilesToTransfer: __expectLong(output.EstimatedFilesToTransfer),
        Excludes: output.Excludes !== undefined && output.Excludes !== null
            ? deserializeAws_json1_1FilterList(output.Excludes, context)
            : undefined,
        FilesTransferred: __expectLong(output.FilesTransferred),
        Includes: output.Includes !== undefined && output.Includes !== null
            ? deserializeAws_json1_1FilterList(output.Includes, context)
            : undefined,
        Options: output.Options !== undefined && output.Options !== null
            ? deserializeAws_json1_1Options(output.Options, context)
            : undefined,
        Result: output.Result !== undefined && output.Result !== null
            ? deserializeAws_json1_1TaskExecutionResultDetail(output.Result, context)
            : undefined,
        StartTime: output.StartTime !== undefined && output.StartTime !== null
            ? __expectNonNull(__parseEpochTimestamp(__expectNumber(output.StartTime)))
            : undefined,
        Status: __expectString(output.Status),
        TaskExecutionArn: __expectString(output.TaskExecutionArn),
    };
};
var deserializeAws_json1_1DescribeTaskResponse = function (output, context) {
    return {
        CloudWatchLogGroupArn: __expectString(output.CloudWatchLogGroupArn),
        CreationTime: output.CreationTime !== undefined && output.CreationTime !== null
            ? __expectNonNull(__parseEpochTimestamp(__expectNumber(output.CreationTime)))
            : undefined,
        CurrentTaskExecutionArn: __expectString(output.CurrentTaskExecutionArn),
        DestinationLocationArn: __expectString(output.DestinationLocationArn),
        DestinationNetworkInterfaceArns: output.DestinationNetworkInterfaceArns !== undefined && output.DestinationNetworkInterfaceArns !== null
            ? deserializeAws_json1_1DestinationNetworkInterfaceArns(output.DestinationNetworkInterfaceArns, context)
            : undefined,
        ErrorCode: __expectString(output.ErrorCode),
        ErrorDetail: __expectString(output.ErrorDetail),
        Excludes: output.Excludes !== undefined && output.Excludes !== null
            ? deserializeAws_json1_1FilterList(output.Excludes, context)
            : undefined,
        Includes: output.Includes !== undefined && output.Includes !== null
            ? deserializeAws_json1_1FilterList(output.Includes, context)
            : undefined,
        Name: __expectString(output.Name),
        Options: output.Options !== undefined && output.Options !== null
            ? deserializeAws_json1_1Options(output.Options, context)
            : undefined,
        Schedule: output.Schedule !== undefined && output.Schedule !== null
            ? deserializeAws_json1_1TaskSchedule(output.Schedule, context)
            : undefined,
        SourceLocationArn: __expectString(output.SourceLocationArn),
        SourceNetworkInterfaceArns: output.SourceNetworkInterfaceArns !== undefined && output.SourceNetworkInterfaceArns !== null
            ? deserializeAws_json1_1SourceNetworkInterfaceArns(output.SourceNetworkInterfaceArns, context)
            : undefined,
        Status: __expectString(output.Status),
        TaskArn: __expectString(output.TaskArn),
    };
};
var deserializeAws_json1_1DestinationNetworkInterfaceArns = function (output, context) {
    var retVal = (output || [])
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return __expectString(entry);
    });
    return retVal;
};
var deserializeAws_json1_1Ec2Config = function (output, context) {
    return {
        SecurityGroupArns: output.SecurityGroupArns !== undefined && output.SecurityGroupArns !== null
            ? deserializeAws_json1_1Ec2SecurityGroupArnList(output.SecurityGroupArns, context)
            : undefined,
        SubnetArn: __expectString(output.SubnetArn),
    };
};
var deserializeAws_json1_1Ec2SecurityGroupArnList = function (output, context) {
    var retVal = (output || [])
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return __expectString(entry);
    });
    return retVal;
};
var deserializeAws_json1_1FilterList = function (output, context) {
    var retVal = (output || [])
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1FilterRule(entry, context);
    });
    return retVal;
};
var deserializeAws_json1_1FilterRule = function (output, context) {
    return {
        FilterType: __expectString(output.FilterType),
        Value: __expectString(output.Value),
    };
};
var deserializeAws_json1_1FsxProtocol = function (output, context) {
    return {
        NFS: output.NFS !== undefined && output.NFS !== null
            ? deserializeAws_json1_1FsxProtocolNfs(output.NFS, context)
            : undefined,
    };
};
var deserializeAws_json1_1FsxProtocolNfs = function (output, context) {
    return {
        MountOptions: output.MountOptions !== undefined && output.MountOptions !== null
            ? deserializeAws_json1_1NfsMountOptions(output.MountOptions, context)
            : undefined,
    };
};
var deserializeAws_json1_1HdfsNameNode = function (output, context) {
    return {
        Hostname: __expectString(output.Hostname),
        Port: __expectInt32(output.Port),
    };
};
var deserializeAws_json1_1HdfsNameNodeList = function (output, context) {
    var retVal = (output || [])
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1HdfsNameNode(entry, context);
    });
    return retVal;
};
var deserializeAws_json1_1InternalException = function (output, context) {
    return {
        errorCode: __expectString(output.errorCode),
        message: __expectString(output.message),
    };
};
var deserializeAws_json1_1InvalidRequestException = function (output, context) {
    return {
        errorCode: __expectString(output.errorCode),
        message: __expectString(output.message),
    };
};
var deserializeAws_json1_1ListAgentsResponse = function (output, context) {
    return {
        Agents: output.Agents !== undefined && output.Agents !== null
            ? deserializeAws_json1_1AgentList(output.Agents, context)
            : undefined,
        NextToken: __expectString(output.NextToken),
    };
};
var deserializeAws_json1_1ListLocationsResponse = function (output, context) {
    return {
        Locations: output.Locations !== undefined && output.Locations !== null
            ? deserializeAws_json1_1LocationList(output.Locations, context)
            : undefined,
        NextToken: __expectString(output.NextToken),
    };
};
var deserializeAws_json1_1ListTagsForResourceResponse = function (output, context) {
    return {
        NextToken: __expectString(output.NextToken),
        Tags: output.Tags !== undefined && output.Tags !== null
            ? deserializeAws_json1_1OutputTagList(output.Tags, context)
            : undefined,
    };
};
var deserializeAws_json1_1ListTaskExecutionsResponse = function (output, context) {
    return {
        NextToken: __expectString(output.NextToken),
        TaskExecutions: output.TaskExecutions !== undefined && output.TaskExecutions !== null
            ? deserializeAws_json1_1TaskExecutionList(output.TaskExecutions, context)
            : undefined,
    };
};
var deserializeAws_json1_1ListTasksResponse = function (output, context) {
    return {
        NextToken: __expectString(output.NextToken),
        Tasks: output.Tasks !== undefined && output.Tasks !== null
            ? deserializeAws_json1_1TaskList(output.Tasks, context)
            : undefined,
    };
};
var deserializeAws_json1_1LocationList = function (output, context) {
    var retVal = (output || [])
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1LocationListEntry(entry, context);
    });
    return retVal;
};
var deserializeAws_json1_1LocationListEntry = function (output, context) {
    return {
        LocationArn: __expectString(output.LocationArn),
        LocationUri: __expectString(output.LocationUri),
    };
};
var deserializeAws_json1_1NfsMountOptions = function (output, context) {
    return {
        Version: __expectString(output.Version),
    };
};
var deserializeAws_json1_1OnPremConfig = function (output, context) {
    return {
        AgentArns: output.AgentArns !== undefined && output.AgentArns !== null
            ? deserializeAws_json1_1AgentArnList(output.AgentArns, context)
            : undefined,
    };
};
var deserializeAws_json1_1Options = function (output, context) {
    return {
        Atime: __expectString(output.Atime),
        BytesPerSecond: __expectLong(output.BytesPerSecond),
        Gid: __expectString(output.Gid),
        LogLevel: __expectString(output.LogLevel),
        Mtime: __expectString(output.Mtime),
        OverwriteMode: __expectString(output.OverwriteMode),
        PosixPermissions: __expectString(output.PosixPermissions),
        PreserveDeletedFiles: __expectString(output.PreserveDeletedFiles),
        PreserveDevices: __expectString(output.PreserveDevices),
        SecurityDescriptorCopyFlags: __expectString(output.SecurityDescriptorCopyFlags),
        TaskQueueing: __expectString(output.TaskQueueing),
        TransferMode: __expectString(output.TransferMode),
        Uid: __expectString(output.Uid),
        VerifyMode: __expectString(output.VerifyMode),
    };
};
var deserializeAws_json1_1OutputTagList = function (output, context) {
    var retVal = (output || [])
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1TagListEntry(entry, context);
    });
    return retVal;
};
var deserializeAws_json1_1PLSecurityGroupArnList = function (output, context) {
    var retVal = (output || [])
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return __expectString(entry);
    });
    return retVal;
};
var deserializeAws_json1_1PLSubnetArnList = function (output, context) {
    var retVal = (output || [])
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return __expectString(entry);
    });
    return retVal;
};
var deserializeAws_json1_1PrivateLinkConfig = function (output, context) {
    return {
        PrivateLinkEndpoint: __expectString(output.PrivateLinkEndpoint),
        SecurityGroupArns: output.SecurityGroupArns !== undefined && output.SecurityGroupArns !== null
            ? deserializeAws_json1_1PLSecurityGroupArnList(output.SecurityGroupArns, context)
            : undefined,
        SubnetArns: output.SubnetArns !== undefined && output.SubnetArns !== null
            ? deserializeAws_json1_1PLSubnetArnList(output.SubnetArns, context)
            : undefined,
        VpcEndpointId: __expectString(output.VpcEndpointId),
    };
};
var deserializeAws_json1_1QopConfiguration = function (output, context) {
    return {
        DataTransferProtection: __expectString(output.DataTransferProtection),
        RpcProtection: __expectString(output.RpcProtection),
    };
};
var deserializeAws_json1_1S3Config = function (output, context) {
    return {
        BucketAccessRoleArn: __expectString(output.BucketAccessRoleArn),
    };
};
var deserializeAws_json1_1SmbMountOptions = function (output, context) {
    return {
        Version: __expectString(output.Version),
    };
};
var deserializeAws_json1_1SourceNetworkInterfaceArns = function (output, context) {
    var retVal = (output || [])
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return __expectString(entry);
    });
    return retVal;
};
var deserializeAws_json1_1StartTaskExecutionResponse = function (output, context) {
    return {
        TaskExecutionArn: __expectString(output.TaskExecutionArn),
    };
};
var deserializeAws_json1_1TagListEntry = function (output, context) {
    return {
        Key: __expectString(output.Key),
        Value: __expectString(output.Value),
    };
};
var deserializeAws_json1_1TagResourceResponse = function (output, context) {
    return {};
};
var deserializeAws_json1_1TaskExecutionList = function (output, context) {
    var retVal = (output || [])
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1TaskExecutionListEntry(entry, context);
    });
    return retVal;
};
var deserializeAws_json1_1TaskExecutionListEntry = function (output, context) {
    return {
        Status: __expectString(output.Status),
        TaskExecutionArn: __expectString(output.TaskExecutionArn),
    };
};
var deserializeAws_json1_1TaskExecutionResultDetail = function (output, context) {
    return {
        ErrorCode: __expectString(output.ErrorCode),
        ErrorDetail: __expectString(output.ErrorDetail),
        PrepareDuration: __expectLong(output.PrepareDuration),
        PrepareStatus: __expectString(output.PrepareStatus),
        TotalDuration: __expectLong(output.TotalDuration),
        TransferDuration: __expectLong(output.TransferDuration),
        TransferStatus: __expectString(output.TransferStatus),
        VerifyDuration: __expectLong(output.VerifyDuration),
        VerifyStatus: __expectString(output.VerifyStatus),
    };
};
var deserializeAws_json1_1TaskList = function (output, context) {
    var retVal = (output || [])
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1TaskListEntry(entry, context);
    });
    return retVal;
};
var deserializeAws_json1_1TaskListEntry = function (output, context) {
    return {
        Name: __expectString(output.Name),
        Status: __expectString(output.Status),
        TaskArn: __expectString(output.TaskArn),
    };
};
var deserializeAws_json1_1TaskSchedule = function (output, context) {
    return {
        ScheduleExpression: __expectString(output.ScheduleExpression),
    };
};
var deserializeAws_json1_1UntagResourceResponse = function (output, context) {
    return {};
};
var deserializeAws_json1_1UpdateAgentResponse = function (output, context) {
    return {};
};
var deserializeAws_json1_1UpdateLocationHdfsResponse = function (output, context) {
    return {};
};
var deserializeAws_json1_1UpdateLocationNfsResponse = function (output, context) {
    return {};
};
var deserializeAws_json1_1UpdateLocationObjectStorageResponse = function (output, context) {
    return {};
};
var deserializeAws_json1_1UpdateLocationSmbResponse = function (output, context) {
    return {};
};
var deserializeAws_json1_1UpdateTaskExecutionResponse = function (output, context) {
    return {};
};
var deserializeAws_json1_1UpdateTaskResponse = function (output, context) {
    return {};
};
var deserializeMetadata = function (output) {
    var _a;
    return ({
        httpStatusCode: output.statusCode,
        requestId: (_a = output.headers["x-amzn-requestid"]) !== null && _a !== void 0 ? _a : output.headers["x-amzn-request-id"],
        extendedRequestId: output.headers["x-amz-id-2"],
        cfId: output.headers["x-amz-cf-id"],
    });
};
var collectBody = function (streamBody, context) {
    if (streamBody === void 0) { streamBody = new Uint8Array(); }
    if (streamBody instanceof Uint8Array) {
        return Promise.resolve(streamBody);
    }
    return context.streamCollector(streamBody) || Promise.resolve(new Uint8Array());
};
var collectBodyString = function (streamBody, context) {
    return collectBody(streamBody, context).then(function (body) { return context.utf8Encoder(body); });
};
var buildHttpRpcRequest = function (context, headers, path, resolvedHostname, body) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, hostname, _b, protocol, port, basePath, contents;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0: return [4, context.endpoint()];
            case 1:
                _a = _c.sent(), hostname = _a.hostname, _b = _a.protocol, protocol = _b === void 0 ? "https" : _b, port = _a.port, basePath = _a.path;
                contents = {
                    protocol: protocol,
                    hostname: hostname,
                    port: port,
                    method: "POST",
                    path: basePath.endsWith("/") ? basePath.slice(0, -1) + path : basePath + path,
                    headers: headers,
                };
                if (resolvedHostname !== undefined) {
                    contents.hostname = resolvedHostname;
                }
                if (body !== undefined) {
                    contents.body = body;
                }
                return [2, new __HttpRequest(contents)];
        }
    });
}); };
var parseBody = function (streamBody, context) {
    return collectBodyString(streamBody, context).then(function (encoded) {
        if (encoded.length) {
            return JSON.parse(encoded);
        }
        return {};
    });
};
var loadRestJsonErrorCode = function (output, data) {
    var findKey = function (object, key) { return Object.keys(object).find(function (k) { return k.toLowerCase() === key.toLowerCase(); }); };
    var sanitizeErrorCode = function (rawValue) {
        var cleanValue = rawValue;
        if (cleanValue.indexOf(":") >= 0) {
            cleanValue = cleanValue.split(":")[0];
        }
        if (cleanValue.indexOf("#") >= 0) {
            cleanValue = cleanValue.split("#")[1];
        }
        return cleanValue;
    };
    var headerKey = findKey(output.headers, "x-amzn-errortype");
    if (headerKey !== undefined) {
        return sanitizeErrorCode(output.headers[headerKey]);
    }
    if (data.code !== undefined) {
        return sanitizeErrorCode(data.code);
    }
    if (data["__type"] !== undefined) {
        return sanitizeErrorCode(data["__type"]);
    }
    return "";
};
