import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { DataSyncClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../DataSyncClient";
import { UpdateLocationNfsRequest, UpdateLocationNfsResponse } from "../models/models_0";
export interface UpdateLocationNfsCommandInput extends UpdateLocationNfsRequest {
}
export interface UpdateLocationNfsCommandOutput extends UpdateLocationNfsResponse, __MetadataBearer {
}

export declare class UpdateLocationNfsCommand extends $Command<UpdateLocationNfsCommandInput, UpdateLocationNfsCommandOutput, DataSyncClientResolvedConfig> {
    readonly input: UpdateLocationNfsCommandInput;
    constructor(input: UpdateLocationNfsCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: DataSyncClientResolvedConfig, options?: __HttpHandlerOptions): Handler<UpdateLocationNfsCommandInput, UpdateLocationNfsCommandOutput>;
    private serialize;
    private deserialize;
}
