import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { DataSyncClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../DataSyncClient";
import { UpdateLocationSmbRequest, UpdateLocationSmbResponse } from "../models/models_0";
export interface UpdateLocationSmbCommandInput extends UpdateLocationSmbRequest {
}
export interface UpdateLocationSmbCommandOutput extends UpdateLocationSmbResponse, __MetadataBearer {
}

export declare class UpdateLocationSmbCommand extends $Command<UpdateLocationSmbCommandInput, UpdateLocationSmbCommandOutput, DataSyncClientResolvedConfig> {
    readonly input: UpdateLocationSmbCommandInput;
    constructor(input: UpdateLocationSmbCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: DataSyncClientResolvedConfig, options?: __HttpHandlerOptions): Handler<UpdateLocationSmbCommandInput, UpdateLocationSmbCommandOutput>;
    private serialize;
    private deserialize;
}
