import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { DataSyncClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../DataSyncClient";
import { CreateLocationFsxLustreRequest, CreateLocationFsxLustreResponse } from "../models/models_0";
export interface CreateLocationFsxLustreCommandInput extends CreateLocationFsxLustreRequest {
}
export interface CreateLocationFsxLustreCommandOutput extends CreateLocationFsxLustreResponse, __MetadataBearer {
}

export declare class CreateLocationFsxLustreCommand extends $Command<CreateLocationFsxLustreCommandInput, CreateLocationFsxLustreCommandOutput, DataSyncClientResolvedConfig> {
    readonly input: CreateLocationFsxLustreCommandInput;
    constructor(input: CreateLocationFsxLustreCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: DataSyncClientResolvedConfig, options?: __HttpHandlerOptions): Handler<CreateLocationFsxLustreCommandInput, CreateLocationFsxLustreCommandOutput>;
    private serialize;
    private deserialize;
}
