import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { DataSyncClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../DataSyncClient";
import { CreateLocationFsxOpenZfsRequest, CreateLocationFsxOpenZfsResponse } from "../models/models_0";
export interface CreateLocationFsxOpenZfsCommandInput extends CreateLocationFsxOpenZfsRequest {
}
export interface CreateLocationFsxOpenZfsCommandOutput extends CreateLocationFsxOpenZfsResponse, __MetadataBearer {
}

export declare class CreateLocationFsxOpenZfsCommand extends $Command<CreateLocationFsxOpenZfsCommandInput, CreateLocationFsxOpenZfsCommandOutput, DataSyncClientResolvedConfig> {
    readonly input: CreateLocationFsxOpenZfsCommandInput;
    constructor(input: CreateLocationFsxOpenZfsCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: DataSyncClientResolvedConfig, options?: __HttpHandlerOptions): Handler<CreateLocationFsxOpenZfsCommandInput, CreateLocationFsxOpenZfsCommandOutput>;
    private serialize;
    private deserialize;
}
