import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { DataSyncClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../DataSyncClient";
import { DescribeLocationFsxLustreRequest, DescribeLocationFsxLustreResponse } from "../models/models_0";
export interface DescribeLocationFsxLustreCommandInput extends DescribeLocationFsxLustreRequest {
}
export interface DescribeLocationFsxLustreCommandOutput extends DescribeLocationFsxLustreResponse, __MetadataBearer {
}

export declare class DescribeLocationFsxLustreCommand extends $Command<DescribeLocationFsxLustreCommandInput, DescribeLocationFsxLustreCommandOutput, DataSyncClientResolvedConfig> {
    readonly input: DescribeLocationFsxLustreCommandInput;
    constructor(input: DescribeLocationFsxLustreCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: DataSyncClientResolvedConfig, options?: __HttpHandlerOptions): Handler<DescribeLocationFsxLustreCommandInput, DescribeLocationFsxLustreCommandOutput>;
    private serialize;
    private deserialize;
}
