import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { DataSyncClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../DataSyncClient";
import { UpdateLocationHdfsRequest, UpdateLocationHdfsResponse } from "../models/models_0";
export interface UpdateLocationHdfsCommandInput extends UpdateLocationHdfsRequest {
}
export interface UpdateLocationHdfsCommandOutput extends UpdateLocationHdfsResponse, __MetadataBearer {
}

export declare class UpdateLocationHdfsCommand extends $Command<UpdateLocationHdfsCommandInput, UpdateLocationHdfsCommandOutput, DataSyncClientResolvedConfig> {
    readonly input: UpdateLocationHdfsCommandInput;
    constructor(input: UpdateLocationHdfsCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: DataSyncClientResolvedConfig, options?: __HttpHandlerOptions): Handler<UpdateLocationHdfsCommandInput, UpdateLocationHdfsCommandOutput>;
    private serialize;
    private deserialize;
}
